unit Missile;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  TurboSprite, DibCanvas;

type
  TMissile = class( TSprite )
  private
  protected
    function GetBoundingRect: TRect; override;
  public
    constructor Create; override;
    procedure Render( ACanvas: TCanvas; ADibCanvas: TDibCanvas ); override;
  published
  end;

implementation

constructor TMissile.Create;
begin
  inherited Create;
  LifeSpan := 75;
end;

function TMissile.GetBoundingRect: TRect;
begin
  Result.Left := Trunc( PositionX ) - 1;
  Result.Top := Trunc( PositionY ) - 1;
  Result.Right := Result.Left + 3;
  Result.Bottom := Result.Top + 3;
end;

procedure TMissile.Render(ACanvas: TCanvas; ADibCanvas: TDibCanvas);
var
  x, y: integer;
begin
  x := Trunc( PositionX ) - SpriteSurface.OffsetX;
  y := Trunc( PositionY ) - SpriteSurface.OffsetY;
  with ADibCanvas do
  begin
    PixelsClipped[x,y] := 255;
    if Random( 100 ) > 30 then
      PixelsClipped[x - 1,y] := 255;
    if Random( 100 ) > 30 then
      PixelsClipped[x,y - 1] := 255;
    if Random( 100 ) > 30 then
      PixelsClipped[x + 1,y] := 255;
    if Random( 100 ) > 30 then
      PixelsClipped[x,y + 1] := 255;
  end;
end;

end.
 